;****************************************************************************
;*
;*	this uilm scans for dirty pages in the current page table
;*	add them to the memory analysis array or stores them into
;*	the address and data table
;*
;*	written 1997 by future vision
;*
;****************************************************************************

.386P

Black		EQU	0
Blue		EQU	1
Green		EQU	2
Cyan		EQU	3
Red		EQU	4
Magenta 	EQU	5
Brown		EQU	6
LightGray	EQU	7

DarkGray	EQU	8
LightBlue	EQU	9
LightGreen	EQU	10
LightCyan	EQU	11
LightRed	EQU	12
LightMagenta	EQU	13
Yellow		EQU	14
White		EQU	15

set_color	MACRO	background,foreground
		mov		[color],(background)*16+foreground
		ENDM

main_seg		SEGMENT	USE16
	ASSUME	CS:main_seg
	ASSUME	DS:main_seg
	ORG	100h

com_entry:	jmp	start_up
	ORG	103h
		DB	'UILM'				;sign
		DW	offset low_mem_end-100h		;size
		DD	0				;no xms
		DD	0
		DW	0011111111b			;features
;			 ^8  ^4  ^0
;internal hotkey and menu calls only

		DB	0				;no def hotkey
		DW	0				;no def intern hotkey
		DW	0				;reserved
		DB	'Dirty pages',0			;name

start_up		PROC	NEAR
;save table addr
		mov		ax,ds:[si+00]
		mov		cs:register_ofs,ax
		mov		cs:register_seg,ds
		mov		ax,ds:[si+0eh]
		mov		cs:array_ofs,ax
		mov		cs:array_seg,ds
		
;where from?
		mov		ah,0
		int		32h
		
		cmp		ax,'IS'
		jne	dos_call
		test		cl,100b
		jz	dos_call
;init segs
		push		cs
		pop		ds
;draw win
@@reset:	set_color	blue,white
		mov		di,160*8
		mov		al,0c9h
		call	write_char
		mov		al,0cdh
		call	write_line
		mov		al,0bbh
		call	write_char
		mov		cx,39
@@win_draw:	mov		al,0bah
		call	write_char
		mov		al,' '
		call	write_line
		mov		al,0bah
		call	write_char
		loop	@@win_draw
		mov		al,0c8h
		call	write_char
		mov		al,0cdh
		call	write_line
		mov		al,0bch
		call	write_char
		mov		di,160*8+4
		set_color	blue,lightgray
		mov		si,offset $win
		call	write_string
		set_color	blue,yellow
		mov		di,49*160+2
		push		di
		mov		color,74h
		mov		al,' '
		call	write_line
		mov		si,help_line
		pop		di
		call	write_string
		mov		color,1fh
		
;check v86 mode
		les		di,register
		mov		eax,es:[di+4]	;cr0
		mov		si,offset $pm_mode
		test		al,1
		jz	error_msg
		mov		si,offset $pg_mode
		bt		eax,31
		jnc	error_msg
		mov		eax,es:[di+0]	;cr3
		and		ax,not 111111111111b
		mov		cr3_reg,eax
		mov		esi,eax
		mov		cx,4		;read 4 bytes
		mov		ah,28h
		int		32h
		mov		eax,es:[si]
		test		al,1
		mov		si,offset $pg_hide
		jz	error_msg

;check displayed data
@@line_start:	mov		ax,current
		cmp		ax,0
		jnl	@@current_ok
		mov		current,0
@@reset_start:	mov		start,0
		jmp	@@line_ok
@@current_ok:	cmp		start,0
		jl	@@reset_start
		cmp		ax,counter
		jb	@@current_ok2
		mov		ax,counter
		dec		ax
		mov		current,ax
@@current_ok2:	sub		ax,start
		jns	@@start_ok
		add		start,ax
		jmp	@@line_ok
@@start_ok:	sub		ax,30
		js	@@line_ok
		add		start,ax
@@line_ok:
;write memory analysis array
@@redraw:	mov		counter,0
		mov		ah,20h		;text color
		mov		bl,1fh
		int		32h
		mov		ah,23h		;number format
		mov		bx,1008h
		int		32h
		
		mov		table_wr,1
		
		mov		di,160*11+80
		lds		si,array
		lodsb
		cmp		al,cs:table
		ja	@@high_table
		mov		cs:table,al
@@high_table:	movzx		cx,al
		jcxz	@@wrote_array
		cmp		cs:table,0
		jne	@@write_array
		inc		cs:table
@@write_array:	mov		bl,1fh
		mov		al,cs:table
		cmp		al,cs:table_wr
		jne	@@no_tag
		mov		bl,5fh
		cmp		cs:mode,1
		je	@@no_tag
		mov		bl,3fh
@@no_tag:	mov		ah,20h
		int		32h
		inc		cs:table_wr

		mov		ah,21h
		mov		bx,di
		int		32h
		lodsd
		mov		ebx,eax
		mov		ah,24h
		int		32h
		mov		ah,21h
		lea		bx,[di+26]
		int		32h
		lodsd
		mov		ebx,eax
		mov		ah,24h
		int		32h
		add		di,160
		loop	@@write_array
@@wrote_array:		
;write dirty page freames
		mov		ah,13h		;switch to pm
		int		32h

		mov		di,160*10+8	;cursor pos

		xor		ebx,ebx
		mov		dl,1

		mov		esi,cr3_reg

		mov		ax,18h
		mov		ds,ax
		mov		cx,400h
		
@@loop_4mb:	lods		dword ptr ds:[esi]
		test		al,1
		jne	@@this_4mb
		call	write_array
		jmp	@@next_4mb
@@this_4mb:	push		ebx
		push		cx
		push		esi

		and		ax,not 111111111111b
		mov		esi,eax
		mov		cx,400h

@@loop_4bk:	lods		dword ptr ds:[esi]
		test		al,1
		jz	@@not_dirty
		test		al,1000000b
		jz	@@not_dirty
		test		dl,1
		jz	@@next_4kb
		mov		edx,ebx			;set start addr
		jmp	@@next_4kb
@@not_dirty:	call	write_array
@@next_4kb:	add		ebx,4*1024
		loop	@@loop_4bk
		
		pop		esi
		pop		cx
		pop		ebx
@@next_4mb:	add		ebx,4*1024*1024
		loop	@@loop_4mb
		call	write_array
		
		mov		ah,14h			;switch to rm
		int		32h

		cmp		di,160*42+8
		ja	@@no_more_line
		sub		di,6-160
		mov		al,' '
@@clear_lines:	call	write_line_h
		add		di,(80-38)*2
		cmp		di,160*48+2
		jb	@@clear_lines
		
@@no_more_line:	mov		ax,current
		cmp		ax,counter
		jae	@@line_start
;****************************************************************************		
		cmp		mark,1
		jne	@@input_loop
		mov		eax,cur_start
		cmp		eax,mark_start
		jae	@@last_start
		mov		mark_start,eax
		jmp	@@redraw
@@last_start:	mov		eax,cur_end
		cmp		eax,mark_end
		jbe	@@last_end
		mov		mark_end,eax
		jmp	@@redraw
@@last_end:

;****************************************************************************
@@input_loop:	cmp		mode,0
		je	@@input
		les		si,array
		cmp		byte ptr es:[si],0
		je	@@mode

@@input:	mov		ah,0
		int		16h

		cmp		al,27		;esc
		je	@@return
		cmp		al,'m'
		jne	@@no_mode
@@mode:		mov		help_line,offset $std_help
		xor		mode,1
		jz	@@reset
		mov		help_line,offset $adv_help
		jmp	@@reset
@@no_mode:

		cmp		mode,0
		jne	@@table_mode
;**************************************************************************
		cmp		al,13		;insert tag
		jne	@@no_marked_add
		mov		mark,0
		mov		ebx,mark_start
		cmp		bl,-1
		je	@@no_marked_add
		mov		edx,mark_end
		jmp	@@add_array
@@no_marked_add:cmp		ah,82		;insert
		jne	@@no_add
		mov		ebx,cur_start
		mov		edx,cur_end
@@add_array:	call	add_array
		jmp	@@reset
@@no_add:
		cmp		al,9		;store
		jne	@@no_tab
		mov		ah,12h
		mov		esi,cur_start
		xor		dx,dx
		int		32h
		jmp	@@input_loop
@@no_tab:	cmp		al,'r'		;reset dirty flags
		jne	@@no_reset
		mov		mark_start,-1
		mov		ah,13h
		int		32h
		mov		esi,cr3_reg
		mov		ax,18h
		mov		ds,ax
		mov		cx,400h

@@r_loop:	lods		dword ptr ds:[esi]
		test		al,1
		jz	@@r_not_present
		push		cx
		push		esi
		and		ax,not 111111111111b
		mov		esi,eax
		mov		cx,400h
@@r_loop2:	lods		dword ptr ds:[esi]
		test		al,1
		jz	@@r_not_present2
		and		byte ptr ds:[esi-4],not 1000000b
@@r_not_present2:
		loop	@@r_loop2
		pop		esi
		pop		cx		
@@r_not_present:loop	@@r_loop
		mov		ah,14h
		int		32h
		jmp	@@redraw
		
@@no_reset:	cmp		al,' '
		jne	@@no_mark
		xor		mark,1
		jz	@@input_loop
		mov		eax,cur_start
		mov		mark_start,eax
		mov		eax,cur_end
		mov		mark_end,eax
		jmp	@@redraw
@@no_mark:	cmp		ah,72		;up
		jne	@@no_up
		dec		current
		jmp	@@line_start
@@no_up:	cmp		ah,80		;down
		jne	@@no_down
		inc		current
		jmp	@@line_start
@@no_down:
		jmp	@@input_loop
;***************************************************************************
@@table_mode:	les		si,array
		
		cmp		ah,83		;del
		jne	@@no_del
		movzx		bx,table
		shl		bx,3
		lea		si,[si+bx+1]
		call	delete_si
		jmp	@@reset
@@no_del:
		cmp		al,'d'		;delete
		jne	@@no_delete
		mov		byte ptr es:[si],0
		jmp	@@reset
@@no_delete:	cmp		ah,72		;up
		jne	@@no_up_t
		cmp		table,0
		je	@@input_loop
		dec		table
		jmp	@@redraw
@@no_up_t:	cmp		ah,80		;down
		jne	@@no_down_t
		mov		al,table
		cmp		al,es:[si]
		je	@@input_loop
		inc		table
		jmp	@@redraw
@@no_down_t:
		jmp	@@input_loop
		
		
error_msg:	mov		di,160*12+10
		call	write_string
		mov		ah,0
		int		16h
@@return:	xor		al,al
		retf
start_up		ENDP
;**************************************************************************
add_array		PROC	NEAR
	LOCALS
		;ebx	start
		;edx	end
		push		ds
		les		si,array
		lods		byte ptr es:[si]
		movzx		cx,al
		jcxz	@@add_array

	;cx	counter

@@check_loop:	lods		dword ptr es:[si]
		mov		edi,eax
		lods		dword ptr es:[si]
		inc		al
		cmp		ebx,eax
		pushf
		dec		al
		popf
		ja	@@next
		inc		dl
		cmp		edx,edi
		pushf
		dec		dl
		popf
		jb	@@next
		cmp		ebx,edi
		jbe	@@no_start_bstart
		mov		ebx,edi
@@no_start_bstart:
		cmp		edx,eax
		jae	@@no_end_bend
		mov		edx,eax
@@no_end_bend:	call	delete_si
@@next:		loop	@@check_loop

@@add_array:	mov		si,array_ofs
		push		si
		lods		byte ptr es:[si]
		cmp		al,10			;array full
		jae	@@sort
		inc		byte ptr es:[si-1]
		cbw
		shl		ax,1+1+1
		add		si,ax
		mov		es:[si],ebx
		mov		es:[si+4],edx

@@sort:		pop		si			;sort array
		lods		byte ptr es:[si]	;badly bubble sort n^2
		movzx		cx,al
		jcxz	@@outer_done
@@outer_loop:	push		si
		push		cx
		dec		cx
		jz	@@inner_done
@@inner_loop:	mov		eax,es:[si]
		cmp		es:[si+8],eax
		jae	@@dont_change
		xchg		eax,es:[si+8]
		mov		es:[si],eax
		mov		eax,es:[si+4]
		xchg		eax,es:[si+12]
		mov		es:[si+4],eax
@@dont_change:	add		si,8
		loop	@@inner_loop
@@inner_done:	pop		cx
		pop		si
		loop	@@outer_loop		
@@outer_done:

@@done:		pop		ds
		ret		
add_array		ENDP
;****************************************************************************
delete_si		PROC	NEAR
	;delete entry at es:[si-8] (analysis array)
		push		si			;delete this
		push		cx
		mov		cx,10*8
		lea		di,[si-8]
		rep movs	byte ptr es:[di],es:[si]
		mov		si,array_ofs
		dec		byte ptr es:[si]
		pop		cx
		pop		si
		sub		si,8
		ret
delete_si		ENDP
;****************************************************************************
write_array		PROC	NEAR
	LOCALS
	;write dirty pages edx - ebx-1
		test		dl,1
		jnz	@@return

		inc		es:[counter]

		push		ax
		mov		ax,es:counter
		cmp		ax,es:start
		pop		ax
		jb	@@dont_draw
		cmp		di,(47-5)*160
		ja	@@dont_draw
		add		di,160
		push		ds
		push		es
		pushad


		push		ebx
		push		edx
		
		mov		cl,1fh
		
		cmp		edx,es:mark_end
		ja	@@no_mark
		cmp		ebx,es:mark_start
		jb	@@no_mark
		mov		cl,7eh
@@no_mark:
		mov		ax,es:current
		inc		ax
		cmp		ax,es:counter
		jne	@@old_color
		
		dec		ebx
		mov		es:cur_start,edx
		mov		es:cur_end,ebx
		inc		ebx
		
		and		cl,5fh
		or		cl,50h
		cmp		es:mode,0
		je	@@old_color
		and		cl,3fh
		or		cl,30h
		
@@old_color:
		mov		bl,cl
		mov		ah,20h
		int		32h
		
		mov		ah,21h
		mov		bx,di
		int		32h
		mov		ah,24h
		pop		ebx
		int		32h
		mov		ah,21h
		lea		bx,[di+26]
		int		32h
		mov		ah,24h
		pop		ebx
		dec		ebx
		int		32h

		popad
		pop		es
		pop		ds
@@dont_draw:	mov		dl,1
@@return:	ret
write_array		ENDP
;****************************************************************************
start		DW	0		;first page displayed
counter		DW	?		;#dirty pages
current		DW	0		;current

mark_start	DD	-1		;tag min
mark_end	DD	-1		;tag max
mark		DB	0		;1=tag mode

cur_start	DD	?		;current min
cur_end		DD	?		;current max

mode		DB	0		;1=analysis table

table		DB	0		;current
table_wr	DB	?		;counter

color		DB	1fh

register	LABEL	DWORD		;register set
register_ofs	DW	?
register_seg	DW	?
array		LABEL	DWORD		;analysis array data
array_ofs	DW	?
array_seg	DW	?

cr3_reg		DD	?		;cr3 reg

$win		DB	' This uilm scans the page tables for dirty frames ',0
$pm_mode	DB	'interrupted program not in protected mode',0
$pg_mode	DB	'interrupted program doesn''t use paging',0
$pg_hide	DB	'the page tables seem to be hidden',0

help_line	DW	offset $std_help	;offs of help line
$std_help	DB	'M-Mode R-Reset INS-Add SPACE-Mark ENTER-Add marked TAB-Store',0
$adv_help	DB	'M-Mode DEL-Delete D-Delete all',0
;****************************************************************************
write_char		PROC	NEAR
		push		ax
		push		es
		push		0b800h
		pop		es
		mov		ah,[color]
		stosw
		pop		es
		pop		ax
		ret
write_char		ENDP
write_line_h		PROC	NEAR
		push		cx
		mov		cx,38
		jmp	@write_line
write_line_h		ENDP
write_line		PROC	NEAR
	LOCALS
		push		cx
		mov		cx,78
@write_line:
@@line_loop:	call	write_char
		loop	@@line_loop
		pop		cx
		ret
write_line		ENDP
write_string		PROC	NEAR
	LOCALS
		push		ax
@@loop_string:	lodsb
		or		al,al
		jz	@@end_string
		call	write_char
		jmp	@@loop_string
@@end_string:	pop		ax
		ret
write_string		ENDP

low_mem_end		LABEL	WORD
;****************************************************************************
dos_call		PROC	NEAR
		mov		dx,offset $no_dos
		mov		ah,9h
		int		21h
		mov		ax,4c00h
		int		21h
dos_call		ENDP
$no_dos		DB	'This uilm scans the page tables for dirty pages - written 1997 by FUTURE VISION',13,10
		DB	'...this is an user interface loadable module and cannot be executed by dos',13,10,'$'
main_seg		ENDS
			END	com_entry
